//	AVR-HID TPI Writer
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	Xtl	Xtl		NX^
portB	-	-	-	-	-	-	-	-		--
portD	x	-	rst	D-	D+	XCK	TXD	RXD		TPIʐM

yATtiny2313z							yATtiny10z
|-BBBBBBBBD|	RXD --[100-1k ohm]--+-- TPIDATA (PB0)
|V765432106|	TXD --[100-1k ohm]--+
>          |	XCK ------------------- TPICLK  (PB1)
|201102345G|	PD5(reset-ctrl) ------- RESET#  (PB3)
|ADDAADDDD-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100100(64), Hi:11011111(DF)
[vusb-20120109/examples/hid-data/firmware/Makefile]Q
Low: 11101111 (EF)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11011 (DB)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (FF)
            +-- SPMEN (SPM 1:, 0:L)

yrhz
Atmel AVR Studio 5 (Version: 5.1.208)	œKIvV: -Os
AVRGCC Version: 3.3.1.27
ATtiny2313	12MHziNX^Uqj
*/
/*
yXVz
2012/04/13	v1.00	Program:    1890 bytes (92.3% Full)	ATtiny2313
					Program:    1966 bytes (24.0% Full)	ATmega88P
					Data:         53 bytes (41.4% Full)

2012/09/29	v1.10	Program:    1912 bytes (93.4% Full)	ATtiny2313
					Data:         53 bytes (41.4% Full)
			EIDOLLN^MǉB
*/

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include <avr/pgmspace.h>
#include "usbdrv.h"

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

PROGMEM char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH] =
{
    0x06, 0x00, 0xff,              // USAGE_PAGE (Vendor Defined Page 1)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8) bit
	
    0x09, 0x00,                    //   USAGE (Undefined)
    0x95, 0x06,                    //   REPORT_COUNT (6)
    0xb1, 0x02,                    //   FEATURE (Data,Var,Abs)
    
	0xc0                           // END_COLLECTION
};

/* ------------------------------------------------------------------------- */

#define CMD_BUF_SIZE	6
#define FEATURE_REPORT_SIZE	CMD_BUF_SIZE
static uint8_t	cmdBuf[CMD_BUF_SIZE];
static uint8_t	bufIndex;
static uint8_t	bytesRemaining;

enum Cmd
{
	//register operation
	CMD_GET,
	CMD_SET,
	CMD_AND,
	CMD_OR,
	CMD_XOR,
	
	//USART operation
	CMD_SEND,
	CMD_RCV,
	CMD_IDOL
};

enum CmdIdx
{
	//ʏ̃WX^	cmdBuf[0:Cmd][1:reg][2:value][3:dmy][4:dmy][5:dmy]
	//A鑗M		cmdBuf[0:Cmd][1:num][2:data1][3:data2][4:data3][5:data4]
	ICmd = 0,
	IReg,	INum = IReg,
	IVal8,	IDat1 = IVal8,
			IDat2,
			IDat3,
			IDat4
};

//RXD/TXD؂ւ
//ETPIDATA{RXD/TXD}̗ɐڑĂ̂ŁAsx؂ւB
#define rxdEnable()		{ UCSRB |= (1 << RXEN); }	//RXDL
#define rxdDisable()	{ UCSRB &= ~(1 << RXEN); }	//RXD(Hi-Z)
#define txdEnable()		{ UCSRB |= (1 << TXEN); }	//TXDL
#define txdDisable()	{ UCSRB &= ~(1 << TXEN); }	//TXD(Hi-Z)

//1byteM
//EMAɎM҂ɐ؂ւB
static void usartSend(uint8_t byteData)
{
	rxdDisable();
	txdEnable();
	while (!(UCSRA & (1 << UDRE))) { }	//obt@󂫑҂
	UCSRA |= (1 << TXC);	//MtOZbgi'1'Ƃ'0'ɂȂj
	UDR = byteData;
	while (!(UCSRA & (1 << TXC))) { }	//M҂
	txdDisable();
	rxdEnable();
}

//IDOLLN^𑗐M
//E1t[(12bit)Ŝ'1'̃t[B12bitȏłB
static void idolChara()
{
	uint8_t	i;
	rxdDisable();
	txdDisable();
	
	PORTD |= (1 << PD1);	//TXD = Hi
	PORTD &= ~(1 << PD2);	//XCK = Lo
	for (i = 0; i < 2 * 12; i++) PIND |= (1 << PD2);	//XCK o͔](HiLoHiLo...HiLo)
}

/* ------------------------------------------------------------------------- */

uchar   usbFunctionRead(uchar *data, uchar len)
{
	uint8_t i;
	if(len > bytesRemaining) len = bytesRemaining;
    
	for (i = 0; i < len; i++)
		data[i] = cmdBuf[bufIndex + i];
	
    bufIndex += len;
    bytesRemaining -= len;
    return len;
}

uchar   usbFunctionWrite(uchar *data, uchar len)
{
	uint8_t i;
	volatile uint8_t *pReg;		//WX^͊mɔf悤volatile
    
	if(bytesRemaining == 0) return 1;	//end of transfer
    if(len > bytesRemaining) len = bytesRemaining;
	
	for (i = 0; i < len; i++)
		cmdBuf[bufIndex + i] = data[i];
    
	bufIndex += len;
    bytesRemaining -= len;
	if (0 < bytesRemaining) return 0;	//return FALSE (data write continue)
	
	//R}h߂Ǝs
	if (cmdBuf[ICmd] == CMD_SEND)
	{
		uint8_t IdxCount = IDat1 + cmdBuf[INum];
		for (i = IDat1; i < IdxCount; i++) usartSend(cmdBuf[i]);
	}
	else if (cmdBuf[ICmd] == CMD_RCV)
	{
		cmdBuf[IReg] = UCSRA;
		if (cmdBuf[IReg] & (1 << RXC)) cmdBuf[IVal8] = UDR;
	}
	else if (cmdBuf[ICmd] == CMD_IDOL)
	{
		idolChara();
	}
	else
	{
		pReg = (uint8_t *)0 + cmdBuf[IReg];
		cli();
		switch (cmdBuf[ICmd])
		{
		case CMD_GET:	cmdBuf[IVal8] = *pReg;	break;
		case CMD_SET:	*pReg = cmdBuf[IVal8];	break;
		case CMD_AND:	*pReg &= cmdBuf[IVal8];	break;
		case CMD_OR:	*pReg |= cmdBuf[IVal8];	break;
		case CMD_XOR:	*pReg ^= cmdBuf[IVal8];	break;
		default:	break;
		}
		sei();
	}
	
    return 1;	//return TRUE if this was the last chunk
}

/* ------------------------------------------------------------------------- */

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
	usbRequest_t *rq = (void *)data;
	
	//HID class request
	//rq->wValue: ReportType (highbyte:[1]), ReportID (lowbyte:[0])
    if((rq->bmRequestType & USBRQ_TYPE_MASK) == USBRQ_TYPE_CLASS)
	{
		if(	rq->bRequest == USBRQ_HID_GET_REPORT	||
			rq->bRequest == USBRQ_HID_SET_REPORT	)
		{
            bufIndex = 0;
			bytesRemaining = FEATURE_REPORT_SIZE;
			return USB_NO_MSG;
		}
    }
	else
	{
        //ignore vendor type requests, we don't use any
    }
    return 0;
}

/* ------------------------------------------------------------------------- */

int main(void)
{
	uint8_t	i;
	
    wdt_enable(WDTO_1S);
	usbInit();
	
	//enforce re-enumeration, do this while interrupts are disabled
	//fake USB disconnect for > 250 ms
	usbDeviceDisconnect();
	i = 0;
	while (--i)
	{
		wdt_reset();
		_delay_ms(1);
	}
	usbDeviceConnect();
	
	sei();
	while (1)
	{
		wdt_reset();
		usbPoll();
    }
	
    return 0;
}
